<?php

namespace console\commands;

use domain\Distribution\Distribution\DistributionModule;
use domain\PointSale\PointSale\PointSaleModule;
use domain\Producer\Producer\Producer;
use domain\Producer\Producer\ProducerModule;
use yii\console\Controller;

class InitPointSaleCreditFunctioningFromSettingsController extends Controller
{
    // ./yii init-point-sale-credit-functioning-from-settings/index
    public function actionIndex()
    {
        $producerModule = ProducerModule::getInstance();
        $pointSaleModule = PointSaleModule::getInstance();

        $producersArray = $producerModule->findProducers();
        foreach($producersArray as $producer) {
            echo '> '.$producer->name."\n";
            \Yii::$app->logic->setProducerContext($producer);
            $pointSaleArray = $pointSaleModule->getRepository()->findPointSales();
            $creditFunctioningProducer = $producerModule->getConfig('credit_functioning');
            foreach($pointSaleArray as $pointSale) {
                if($pointSale->payment_method_credit && !$pointSale->credit_functioning) {
                    $pointSale->credit_functioning = $creditFunctioningProducer;
                    if($pointSale->credit_functioning == Producer::CREDIT_FUNCTIONING_OPTIONAL) {
                        $pointSale->payment_method_onsite = 1;
                    }
                    $pointSale->save();
                    echo 'Point de vente "'.$pointSale->name. '" configuré sur "'.$pointSale->credit_functioning.'"'."\n";
                }
            }
        }
    }
}

?>